
import ogr

def get_ogr_datasource(path):
    """object return must be explicitly destroyed with Destroy()"""
    return ogr.Open(path, update=0)
        
def source_info(path, typename):
    ds = get_ogr_datasource(path)
    layer = ds.GetLayerByName(typename)
    # schema
    ldef = layer.GetLayerDefn()
    types = ['int', 'int', 'float', 'float', 'string', 'string']
    schema = []
    for i in range(ldef.GetFieldCount()):
        fdef = ldef.GetFieldDefn(i)
        schema.append([fdef.GetName(), types[fdef.GetType()]])
    # srs        
    srs = layer.GetSpatialRef().ExportToWkt()
    # bounds
    e = layer.GetExtent()
    ds.Destroy()
    return {'typename': typename, 'schema': schema, 
            'srs': srs, 'bounds': (e[0], e[2], e[1], e[3])}

if __name__ == '__main__':
    print source_info('test.ovf', 'point')
